= 4.4.9.1 - 2025.11.26 =
* Fix translation notices
* Other code fixes

= 4.4.9 - 2025.06.10 =
* Fix: Custom code for cloning from external plugins.
* Code improvements

= 4.4.8 - 2025.04.24 =
* Fix: Cron scheduling - do not schedule cloner cron on sub-sites
* Fix: PHP notice on number precision
* Code improvements

= 4.4.7.5 - 2024.11.25 =
* Fix: Text domain loading

= 4.4.7.4 - 2024.11.13 =
* Fix: Correct theme set on the cloned site from the source site
* Fix: PHP notices

= 4.4.7.3 - 2024.10.17 =
* Cron subsite fixes
* Other improvements.

= 4.4.7.2 - 2024.08.28 =
* Cron code execution fix

= 4.4.7.1 - 2024.08.27 =
* Code improvements

= 4.4.7 - 2024.08.20 =
* Fix PHP notices and other code improvements

= 4.4.6 - 2024.08.08 =
* Better handling of scheduled actions.
* Code improvements.

= 4.4.5 - 2024.06.20 =
* Add hooks to bypass immediate cloning in the admin ajax action.
* Fix initial form setting option loading. Hide those that are not for current clone option.

= 4.4.4 - 2024.05.13 =
* Code updates and other improvements.

= 4.4.2 - 2024.01.30 =
* Enhancement: Improved locale loading.
* Fix: PHP notices.

= 4.4.1 - 2024.01.25 =
* New: Introduce new function `ns_cloner_perform_clone` to make it easier to perform cloning from other plugins.
* Enhancement: Improved checks for file loading.
* Fix: PHP notices.

= 4.4 - 2023.11.20 =
* New: Updated the admin area for a more modern experience.
* Enhancement: Code improvements.

= 4.3.3 - 2023.08.23 =
* Enhancement: Better loading of cloner core files for frontend
* Fix: Clone templates

= 4.3.2 - 2023.08.15 =
* Fix: Fix issues with Background process class in initializing clone

= 4.3.1 - 2023.08.11 =
* Fix vendor paths

= 4.3 - 2023.08.11 =
* Enhancement: Better dependency management
* Enhancement: Ability to override and define own custom logs location. Use `NS_CLONER_LOG_DIR` to define a custom log directory. Use `NS_CLONER_LOG_URL` to define a custom log url.
* Fix: PHP Compatibility with Background process manager
* Fix: PHP Notices

= 4.2.2.2 - 2023.05.09 =
* Fix critical php error

= 4.2.2.1 - 2022.12.19 =
* Remove unnecessary vendor files

= 4.2.2 - 2022.12.16 =
* Fix table constraint issue when cloning
* Update plugin url

= 4.2.1 - 2022.09.19 =
* Fix inaccurate memory limit warning
* Fix default cloning mode selection
* Remove unnecessary vendor files

= 4.2.0 - 2022.08.25 =
* Improve cache flushing logic
* Improve internal coding standards
* Fix handling for undefined classes in serialized values

= 4.1.9.3 - 2022.01.06 =
* Optimize with reduction of unnecessary all hook when not cloning

= 4.1.9.2 - 2022.01.03 =
* Fix compatibility issue with WP Simple Pay

= 4.1.9.1 - 2021.12.23 =
* Optimize performance by preventing initialization for non-admin requests
* Fix unnecessary object cache flushes and add filter to disable entirely

= 4.1.8 - 2021.09.30 =
* Optimize WP site list for networks with large numbers of sites
* Add proactive resolution attempts for duplicate option keys during cloning
* Fix misc. other plugin compatibility issues

= 4.1.7 - 2021.09.02 =
* Apply styling tweaks to admin interface
* Fix bug with networks where the root/main blog ID is not equal to 1
* Fix bug with "Delete All Plugin Data" reset button not working fully
* Fix compatibility issue with Collisimo Shipping Methods plugin

= 4.1.6 - 2021.05.31 =
* Update composer dependencies for PHP 8 compatibility

= 4.1.5.3 - 2021.02.10 =
* Fix compatibility error with SEO by Rank Math Pro

= 4.1.5.2 - 2021.02.03 =
* Fix bug with new site title not being applied after cloning

= 4.1.5.1 - 2021.02.02 =
* Fix slug change that broke compatibility with pro version

= 4.1.5 - 2021.01.31 =
* Add wp_cache_flush() call to resolve object caching issues
* Add option to clear plugin data for stuck processes
* Update internationalization to follow WP recommendations
* Fix misc. warnings, typos

= 4.1.4 - 2020.12.30 =
* Fix visibility error on magic wakeup method
* Fix cache clearing mechanism for WP Engine sites
* Fix conflict with Woo Discount Rules

= 4.1.3 - 2020.11.17 =
* Add new options to help avoid database view / constraint errors
* Make compatible with pro SFTP transfer feature
* Fix inefficient database calls, unresponsive analytics setting UI

= 4.1.0 - 2020.09.25 =
* Add productivity statistics capture and analytics
* Fix jQuery 1.8 compatibility, debug notices, more misc. bugfixes

= 4.0.9 - 2020.06.15 =
* Add new performance control options
* Simplify and improve new site URL validation
* Fix handling for memory limit of -1
* Fix compatibility issue with Yoast WP SEO
* Fix other bugs with stalled clone recovery, notices from options table, etc.

= 4.0.8 - 2020.06.11 =
* Add automatic cache flush after cloning
* Add new filters for performance tweaking and search/replace control
* Fix upload_path replacement for root site with hardcoded upload_path
* Fix sites with non-latin chars in site title being unavailable for cloning
* Fix other bugs with failed finishes, database prefix irregularities, etc.

= 4.0.7 - 2020.01.30 =
* Fix non-prefixed custom tables being included in root site clone
* Fix private/public blog property not being reflected on cloned sites

= 4.0.6 - 2020.01.13 =
* Update admin styles for WP 5.3 UI changes
* Add new recovery capability for stalled cloning processes
* Fix bugs with serialized search/replace updates, unnecessary sitemeta cloning

= 4.0.5 - 2019.10.17 =
* Enable number-only site names
* Add automatic cache-flush at end of cloning for WPEngine sites
* Fix memory/time overload when queueing very large tables
* Fix misc. plugin compatibility issues

= 4.0.4 - 2019.09.02 =
* Fix database handling for null values
* Fix fatal site creation error in pre-5.1 WordPress
* Fix error on servers that don't allow multiple SQL statements in one query
* Fix misc other bugs and plugin compatibility issues

= 4.0.3 - 2019.08.19 =
* Fix missing rows due to lost insert or incorrect row query
* Fix max_allowed_packet database error

= 4.0.2 - 2019.08.15 =
* Fix timing conflicts for cleanup tasks.
* Fix issue where process would keep running after manually cancelling.
* Rewrite row processing class for much better performance and fewer queries.
* Add fallback AJAX process dispatching for environments where background requests stall.
* Add queue batching for large tables.
* Improve debug logging.

= 4.0.1 - 2019.07.26 =
* Fix lock timing on background processes to prevent frozen or conflicting processes.
* Fix handling for SQL views - exclude from table cloning and create at end instead.
* Fix empty target site url caused by object caching on some servers.

= 4.0.0 - 2019.07.22 =
* Release all new rebuilt V4.

= 3.0.7 =
* Replaced deprecated wp_get_sites() with get_sites()

= 3.0.6.0 =
* Fixed an issue where some serial arrays get treated as objects instead of arrays and search/replace was getting missed
* Updated Kint library to resolve issues on some rare environments running OPCache and XCache

= 3.0.5.9 =
* Updated PHP 7 compatibility to use proper global variable variable emulation

= 3.0.5.8 =
* Fixed bug with search and replace preventing multiple replacements in rare cases where the search is different but the replace value is the same.

= 3.0.5.7 =
* Added new feature to save default site template for re-use in cloning every time

= 3.0.5.6 =
* Update to prevent kint classes from causing fatal error when autoloaded by another plugin or tool

= 3.0.5.5 =
* Update to work around WP version changes that prevent site names with dashes in the wpmu_validate_blog_signup() check

= 3.0.5.4 =
* Fixed issue with latest version of WP where a test validation site name containing only numbers is no longer valid

= 3.0.5.3 =
* Small formatting fix to sidebar
* Fixed php Notice: Undefined variable: query when WP_DEBUG is true under certain conditions
* Updated README

= 3.0.5.2 =
* Fixed mysql errors for unquoted numeric strings and empty values

= 3.0.5.1 =
* Fixed INSERT logic bug that resulted in some rows not being copied
* Fixed extra characters in sites cloned via quick clone link
* Better javascript error reporting

= 3.0.5 =
* Refactored MySQL INSERT commands to increase performance and resolve duplicate value issues with several plugins
* Added better MySQL CONSTRAINT handling to fix compatibility issues with several plugins
* Added fix for sites using the Wishlist Member plugin

= 3.0.4.9 =
* Fixed title replacement bug

= 3.0.4.8 =
* Fixed one-click cloning issue
* Fixed a few bugs relating to upload paths and replacements

= 3.0.4.7 =
* Added WP 4.1 compatibility status
* Added additional error handling for systems that can't read external feeds for the sidebar

= 3.0.4.6 =
* Added compatibility fix for CSS & Javascript Toolbox plugin

= 3.0.4.5 =
* Adding compatibility fix for User Access Manager plugin
* Removed site title find/replace functionality

= 3.0.4.4 =
* Added support for new feature and setting in Content and Users Add-on to send notifications to new users

= 3.0.4.3 =
* Added another condition on ensuring kintParser is not already loaded from somewhere else

= 3.0.4.2 =
* Added condition to only load Kint (used for logging) if no other plugin already has

= 3.0.4.1 =
* Fixed minor issue and removed [[ *Notice*: Undefined variable: default_db_creds ]] showing up with WP_DEBUG turned on
* Corrected mismatched version between plugin and logs
* Added basic, disabled feature for emailing new users with site login and password (not currently active - primarily preparation for a new Registration Templates Add-on feature and option)

= 3.0.4 =
* Added one-click cloning from Manage Sites page
* Added pre WP 3.7 compatibility
* New search selector for source sites
* Revamped logs for better utility/readability
* Centralized ns_cloner_addon class for maintability

= 3.0.3.1 =
* Fixed bug introduced in 3.0.3 affecting subdirectory mode

= 3.0.3 =
* Added exception for subsite names to include dashes
* Updates to support new Registration Templates add-on

= 3.0.2 =
* Fixed conflicts with some other multisite plugins that were triggering validation errors when attempting a clone
* Raised number of sites shown by default in "Select Source" dropdown from 100 to 1000 and made parameters for that query filterable

= 3.0.1 =
* Fixed www vs. non-www issue on subdomain installs that were using www and generating sites like site.www.domain.com
* Added robust new detection system for identifying WP version and uploads location even under abnormal edge cases
* Added advanced validation and preemptive issue detection
* Added robust system configuration and action logging to help with troubleshooting
* Added All new Custom Add-on Architecture
* Added All new hook-rich cloning pipeline for developers to extend
* Added All new dynamic, responsive admin interface

= 2.1.4.9 =
* Fixed several small bugs reported to support that impacted specific scenarios, configurations, and plugin combinations.

= 2.1.4.8 =
* Fixed bug that was causing UTF-8 and DB character encoding issues in some environments. Primarily affected non-English sites.

= 2.1.4.7 =
* Fixed critical bug that prevented user roles from getting cloned when cloning the ROOT site only

= 2.1.4.6 =
* Fixed critical bug that was causing incompatibilities with some plugins that install their own tables to the database and in some cases the cloning operation was leaving a single custom table behind in the clone. This primarily affected Calendar plugins or other plugins where the table name began with higher letters (a, b, c) after the prefix like wp_a*, wp_b*, wp_c*

= 2.1.4.5 =
* Added support for cloning the root site with ID 1 (YAY! PLEASE SEE STANDARD PRECAUTIONS AND NOTES ON DESCRIPTION PAGE)
* Added support for WP Multisite when installed in a subdirectory rather than at the root of a domain (there were previously issues in this scenario)
* Added validation to enforce lowercase and only allowed characters in the site name field
* Added validation to enforce replacement rules that aren't always obvious (you don't want the old site name to be contained in the new site domain or the cloner's automated data replacement will corrupt your new clone's data)
* Fixed permalink bug in subdirectory mode
* Updated the way the status is returned after cloning to fix issues where the status exceeds URL length restrictions
* [EXPERIMENTAL] Added support for the ThreeWP Broadcast plugin based on user contribution (thank you John @ propanestudio.com and Aamir!)
* Many other small tweaks, updates, and fixes

= 2.1.4.4 =
* Enhanced media file copy handling from 2.1.4.3

= 2.1.4.3 =
* Added better media file copy handling in cases where themes or plugins alter wp_upload_dir() and it is returning bad paths

= 2.1.4.2 =
* Fixed bug reported by Christian (Thank you!) where some upload file paths containing the same numbers as site IDs were getting mangled

= 2.1.4.1 =
* Fixed 2.1.4 to make file copies compatible with the new uploads structure in native WP 3.5 installs
* ANNOUNCING NS Cloner Pro is now Available [HERE](https://neversettle.iljmp.com/1/ns-cloner-pro)

= 2.1.4 =
* Fixed bug in 2.1.3 that caused file copies to fail in some cases where the target folders already existed

= 2.1.3 =
* Fixed bug in 2.1.2 that forced subdirectory mode

= 2.1.2 =
* Added Auto-detect of Multisite mode and Subdirectory site support!
* Added Automatic Copy of all media files in blogs.dir/##
* Fixed some image loading fails in certain scenarios

= 2.1.1 =
* First public release